package body Generic_Stacks is

   procedure Put_Image
     (Output : in out Ada.Strings.Text_Buffers.Root_Buffer_Type'Class;
      S      : Stack)
   is
      First : Boolean := True;
   begin
      Output.Put ("[");
      for V of S.Data (1 .. S.Count) loop
         if not First then
            Output.Put (", ");
         end if;
         First := False;
         Output.Put (V'Image);
      end loop;
      Output.Put ("]");
   end Put_Image;

   function Model (S : Stack) return Stack_Model
   is (Stack_Model (S.Data (1 .. S.Count)));

   function Pop (S : in out Stack) return Element_T is
   begin
      S.Count := @ - 1;
      return S.Data (S.Count + 1);
   end Pop;

   procedure Push (S : in out Stack; E : Element_T) is
   begin
      S.Count := @ + 1;
      S.Data (S.Count) := E;
   end Push;

end Generic_Stacks;
